
// rev 19-04-2023

#include <xc.h>
#include <pic18f27k42.h>
#include "OneWire_2023.h"

#define onewirePin PORTAbits.RA0
#define onewirePinDirection TRISAbits.TRISA0 //0 = output, 1 = input
#define onewirePin0 PORTAbits.RA0
#define onewirePinDirection0 TRISAbits.TRISA0 //0 = output, 1 = input
#define onewirePin1 PORTAbits.RA1
#define onewirePinDirection1 TRISAbits.TRISA1 //0 = output, 1 = input
#define onewirePin2 PORTAbits.RA2
#define onewirePinDirection2 TRISAbits.TRISA2 //0 = output, 1 = input


void onewireWriteBit_X(int b) 
{
  b = b & 0x01;
  if (b) {
    // Write '1' bit
    onewirePinDirection = 0;
    onewirePin = 0;
    __delay_us(5);
    onewirePinDirection = 1;
    __delay_us(60);
  } else {
    // Write '0' bit
    onewirePinDirection = 0;
    onewirePin = 0;
    __delay_us(70);
    onewirePinDirection = 1;
    __delay_us(2);
  }
}


void onewireWriteBit_0(int b) 
{
  //b = b & 0x01;
  if (b>0) {
    // Write '1' bit
       onewirePinDirection0 = 0;
       onewirePin0 = 0;
        __delay_us(5);
        onewirePinDirection0=1;  
      __delay_us(60);
  } else
    {
    // Write '0' bit
    onewirePinDirection0 = 0;
    onewirePin0 = 0;
    __delay_us(70);
    onewirePinDirection0 = 1;
    __delay_us(2);
  }
}

void onewireWriteBit_2(int b) 
{
 // b = b & 0x01;
  if (b>0) {
    // Write '1' bit
       onewirePinDirection2 = 0;
       onewirePin2 = 0;
        __delay_us(5);
        onewirePinDirection2=1;  
      __delay_us(60);
  } else
    {
    // Write '0' bit
    onewirePinDirection2 = 0;
   onewirePin2 = 0;
    __delay_us(70);
    onewirePinDirection2 = 1;
    __delay_us(2);
  }
}

void onewireWriteBit_1(int b) 
{
//  b = b & 0x01;
  if (b>0) {
    // Write '1' bit
       onewirePinDirection1 = 0;
       onewirePin1 = 0;
        __delay_us(5);
        onewirePinDirection1=1;  
      __delay_us(60);
  } else
    {
    // Write '0' bit
    onewirePinDirection1 = 0;
   onewirePin1 = 0;
    __delay_us(70);
    onewirePinDirection1 = 1;
    __delay_us(2);
  }
}


unsigned char onewireReadBit_X() 
{
  unsigned char result;
  onewirePinDirection = 0;
  onewirePin = 0;
  __delay_us(1);
  onewirePinDirection = 1;
  __delay_us(5);
  result = onewirePin;
  __delay_us(55);
  return result;
}



unsigned char onewireReadBit_0() {
  unsigned char result;
  onewirePinDirection0 = 0;
  onewirePin0 = 0;
  __delay_us(1);
  onewirePinDirection0 = 1;
  __delay_us(5);
  result = onewirePin0;
  __delay_us(55);
  return result;
}


unsigned char onewireReadBit_1() {
  unsigned char result;
  onewirePinDirection1 = 0;
  onewirePin1 = 0;
  __delay_us(1);
  onewirePinDirection1 = 1;
  __delay_us(5);
  result = onewirePin1;
  __delay_us(55);
  return result;
}


unsigned char onewireReadBit_2() {
  unsigned char result;
  onewirePinDirection2 = 0;
  onewirePin2 = 0;
  __delay_us(1);
  onewirePinDirection2 = 1;
  __delay_us(5);
  result = onewirePin2;
  __delay_us(55);
  return result;
}


unsigned char onewireInit_X() {
  onewirePinDirection = 0;
  onewirePin = 0;
  __delay_us(500);
  onewirePinDirection = 1;
  __delay_us(60);
  if (onewirePin == 0) {
      __delay_us(100);
      return 1;
  }
  return 0;
}

unsigned char onewireInit_0()
{
  onewirePinDirection0 = 0;
  onewirePin0 = 0;
  __delay_us(500);  // 480S minimum!
  onewirePinDirection0 = 1;
  __delay_us(60); //15  60 S
  if (onewirePin0 == 0) {
      __delay_us(100);//480S mini
      return 1;
  }
  return 0;
}

unsigned char onewireInit_1()
{
  onewirePinDirection1 = 0;
  onewirePin1 = 0;
  __delay_us(500);  // 480S minimum!
  onewirePinDirection1 = 1;
  __delay_us(60); //15  60 S
  if (onewirePin1 == 0) {
      __delay_us(100);//480S mini
      return 1;
  }
  return 0;
}

unsigned char onewireInit_2() {
  onewirePinDirection2 = 0;
  onewirePin2 = 0;
  __delay_us(500);
  onewirePinDirection2 = 1;
  __delay_us(60);
  if (onewirePin2 == 0) {
      __delay_us(100);
      return 1;
  }
  return 0;
}


unsigned char onewireReadByte_X()
{
  unsigned char result = 0;
  unsigned char loop0;
  for ( loop0 = 0; loop0 < 8; loop0++) 
  {
    // shift the result to get it ready for the next bit
    result >>= 1;
    // if result is one, then set MS bit
    if (onewireReadBit_X()>0)
      result |= 0x80;
  }
  return result;
}


unsigned char onewireReadByte_0() {
  unsigned char result = 0;
  unsigned char loop0;
  for ( loop0 = 0; loop0 < 8; loop0++) {
    // shift the result to get it ready for the next bit
    result >>= 1;
    // if result is one, then set MS bit
    if (onewireReadBit_0()>0)
      result |= 0x80;
  }
  return result;
}


unsigned char onewireReadByte_1() {
  unsigned char result = 0;
  unsigned char loop0;
  for ( loop0 = 0; loop0 < 8; loop0++) {
    // shift the result to get it ready for the next bit
    result >>= 1;
    // if result is one, then set MS bit
    if (onewireReadBit_1()>0)
      result |= 0x80;
  }
  return result;
}


unsigned char onewireReadByte_2() {
  unsigned char result = 0;
  unsigned char loop0;
  for ( loop0 = 0; loop0 < 8; loop0++) {
    // shift the result to get it ready for the next bit
    result >>= 1;
    // if result is one, then set MS bit
    if (onewireReadBit_2()>0)
      result |= 0x80;
  }
  return result;
}


void onewireWriteByte_X(char datax)
{
  unsigned char loop;
  for ( loop = 0; loop < 8; loop++) 
  {
    onewireWriteBit_X(datax & 0x01);
    datax >>= 1;
  }
}

void onewireWriteByte_0(char datax)
{
 unsigned char loop;
  for ( loop = 0; loop < 8; loop++) 
  {
    onewireWriteBit_0(datax & 0x01);
    datax >>= 1;
  }
}


void onewireWriteByte_1(char datax)
{
  // Loop to write each bit in the byte, LS-bit first
    unsigned char loop;
  for ( loop = 0; loop < 8; loop++) 
  {
    onewireWriteBit_1(datax & 0x01);
    // shift the data byte for the next bit
    datax >>= 1;
  }
}

void onewireWriteByte_2(char datax)
{
  unsigned char loop;
  for ( loop = 0; loop < 8; loop++) 
  {
    onewireWriteBit_2(datax & 0x01);
    datax >>= 1;
  }
}


unsigned char onewireCRC(unsigned char* addr, unsigned char len) {
  unsigned char i, j;
  unsigned char inbyte=0;
  unsigned char mix=0;
  unsigned char crc = 0;
  for (i = 0; i < len; i++)
  {
    inbyte = addr[i];
    for (j = 0; j < 8; j++)
    {
      mix = (crc ^ inbyte) & 0x01;
      crc >>= 1;
      if (mix) crc ^= 0x8C;
      inbyte >>= 1;
    }
  }
  return crc;
}

