/*
 * File:   main.c
 * Author: PB
 * Interface SPI mode software
 * PIC 18F4525 et module MAX7219 64 leds
 * DIN = PORTC.5, CS = PORTC.0, CLK = PORTC.3
 * Cration le 25/11/2014
 * Version 1B
 * Modifier le 06/12/2014
 * L'criture du programme priviligie la facilit de lecture, il est donc
 * possible de modifier le programme pour obtenir un programme plus compact
 *
 * Affichage dfilant de constantes et de variables
 */

#include "xc.h"
#include "config.h"
#include <stdint.h>
#include "ctype.h"
#include <stdbool.h>
#include <stdio.h>
#include <limits.h>
#include <string.h>

#include "i2c1_master.h"
#include "i2c1_master_example.h"
#include "UART1_Functions.h"
#include "RTC_DS3231_2023-06.h"  

#ifndef Byte
#define Byte  unsigned char
#endif
#ifndef Word
#define Word  uint16_t
#endif

#define Directory "C:\\MPLABX_Projects\\_18F27K42_Horloge_12xMax7219_2023.X"
#define Project  "_18F27K42_Horloge_12xMax7219_2023"
#define Source   " main.c "
#define Annexe   " XC8 V2.36 C99  Pack: PIC18F-K_DFP 1.6.125"
#define Others   " config.h,table_char.h,RTC_DS3231_06.h ,One_Wire_2023.h "
#define Eeprom   " ..."       //Eeprom_PIC_2023.h"
#define Hardware " Base 18F27K42 "
#define Config   " Internal Fosc 64MHz"

#define PACK "PIC18F-K_DFP 1.6.125"
#define Nb_Matrices 12

#define VERSION "2023-0601"
// rajout cde BAVA
//#define VERSION "2023-0529"
// because  bug (corrig) sur Display_Date_Time(0) 
//#define VERSION "2023-0527"
// bug sur txt=&TEXTE[0]; ????
//  https://fantaspic.fr/viewtopic.php?f=10&t=1313
//essai adaptation Horloge 8V sans 96 decalages ..BAD ! car Max7219 cabl differement
//#define VERSION "2023-0526"
// version 96 decalages 12 x Max7219H
// check global sans Dialogue_Horloge_via_UART_RX.c

//#define VERSION "2023-0525"
// chek Update(



#define CR 13
#define LF 10
#define TAB 9
#define TABUL PrintChar(9);


#include "THIN_SS_2020.h"

#include "i2c1_master.h"
#include "i2c1_master_example.h"
#include "OneWire_2023.h"
#include "DS18B20_2023.h" 
#include "font_ascii_5x8_V.h"

#define SPI_CS LATCbits.LATC0
#define SPI_CLOCK LATCbits.LATC1
#define SPI_DOUT LATCbits.LATC5
#define Led_Rouge  LATAbits.LA4
#define Led_Rouge_Dir  TRISAbits.TRISA4
#define RTC_Forcee  PORTBbits.RB2
#define RTC_Forcee_Dir  TRISBbits.TRISB2
#define Bavard_Forcee  PORTBbits.RB1
#define Bavard_Forcee_Dir  TRISBbits.TRISB1



#define ON  0   // car  R de rappel au +Vcc sur led 
#define OFF 1

#define REG_DECODE        0x09                        // "decode mode" register
#define REG_INTENSITY     0x0A                        // "intensity" register
#define REG_SCAN_LIMIT    0x0B                        // "scan limit" register
#define REG_SHUTDOWN      0x0C                        // "shutdown" register
#define REG_DISPLAY_TEST  0x0F                        // "display test" register
#define INTENSITY_MIN     0x00                        // minimum display intensity  1/32
#define INTENSITY_MAX     0x0F                        // maximum display intensity  31/32
#define INTENSITY_MOY     0x07                        // moyenne 15/32

#define Dx __asm("NOP"); __asm("NOP");

#define UART1_RX_BUFFER_SIZE 128  

#define With_Test_Presence_Devices 

  const  char Msg0[]=" PIC18F27K42 + texte defilant sur 12 matrices MAX7219\r\n";
  const  char Msg1[]=" Directory :"Directory"\r\n";
  const  char Msg2[]=" Project : "Project"\r\n";
  const  char Msg3[]=" Source : "Source"_"VERSION"\r\n";
  const  char Msg4[]=" Config "Config"\r\n";
  const  char Msg5[]=" Autres : "Others"\r\n";
  const  char Msg6[]=" Eeprom :"Eeprom"\r\n";
  const  char Msg7[]=" 3 blocs de 4 matrices 8x8 Max7219\r\n";
  const  char Msg8[]=" SPI RC0=CS ,RC1=CLCK,RC5=DOUT   UART 115200 bds  RA0= OWS DS18B20\r\n";
  const  char Msg9[]=" RTC sur bus I2C1 HW : RC3=SCL,RC4=SDA\r\n RB1 =Bavard Forcee , RB2==RTC Forcee\r\n";
  const  char * Messages[]={Msg0,Msg1,Msg2,Msg3,Msg4,Msg5,Msg6,Msg7,Msg8,Msg9};
  const  char Blancs[]="  ";
  
unsigned char save_bsr ; // BSR
unsigned char save_w  ; //WREG
#define OFFSET  0x0020
unsigned long temps[24] __at (0x0020);
   // 8 lignes de 3 x (4x8) bits = 8 lignes de 96 bits
char Bouclage __at(OFFSET+96);   // pour 96 bits        absolute OFFSET+70; // pour 64 bits
unsigned char Aff_Buffer[768];//   768= 8x 12* 8 + eventuell string terminator=0

// variables Globales usuelles 
unsigned int  i,j,k,l,m,n;
unsigned char  c1,c2,c3,cx,cc;
int j0;
int k0;
unsigned int Nb_Boucles=0;
volatile unsigned char Buffer1[UART1_RX_BUFFER_SIZE];
volatile unsigned int Index1,i1;
volatile unsigned char Flag_Buffer1=0;
volatile unsigned char TEXTE [128];
volatile unsigned char * txt;
char Bavard=0;
bool Status_GIE_Bit;  
__bit init_flag;
int Count_RB0=0;

unsigned char CRam1[128];
unsigned char Tampon[32];

float F0,F1,F2,F3;

unsigned char * p0;
unsigned char * px;
unsigned char * p1;
unsigned char * p2;
unsigned char * p3;
unsigned char * pB;

// Pointeurs sur les differentes zones de Data dans la  TRame
//  afficher sur les 12 max7219
unsigned char * pT=0;
unsigned char * pJ=0;
unsigned char * pM=0;
unsigned char * pA=0;
unsigned char * pI=0;
unsigned char * pE=0;
unsigned char * pS=0;
unsigned char * pD=0;

volatile uint16_t Count0, Count1 ;
volatile uint16_t Cpt0, Cpt1, Cpt2,Cpt3;    
volatile uint16_t Flag_Timer1=0;
volatile uint16_t Flag_Timer2=0;
volatile uint16_t Flag_Timer3=0;
volatile uint16_t Flag_Timer4=0;
volatile uint16_t Flag_Timer6=0;
volatile signed int  Cpt6;  // decompteur
volatile  signed int Cpt4;// decompteur
//unsigned int Duree_Appui=0;
bool Status_GIE_Bit;

unsigned long SMT1_Measure;
unsigned  char *ST;
unsigned long  L1=0;
unsigned long  L2=0;

volatile struct Anybits {   // 8 flags
       unsigned  Tmr0_Elapsed:1;     // for timer0 16bits
       unsigned  Tmr1_Elapsed:1;     // for timer1 16bits
       unsigned  Tmr2_Elapsed:1;     // for timer2 8bits
       unsigned  Tmr3_Elapsed:1;     // for timer3 16bits
       unsigned  Tmr4_Elapsed:1;     // for timer4 8bits
       unsigned  Tmr6_Elapsed:1;     // for timer6 8bits
       unsigned  First_Run :1;   // for NCO
       unsigned  Once :1;          
 }Drapeaux ;  

int Flag_RB0=0;

char Mode=1;
static unsigned char Lettre_Degre_C[8]    ={0x70,0x50,0x77,0x04,0x04,0x04,0x04,0x07}; // Char 176   + C
static unsigned char Lettre_TemperEgal[8] ={0xF8,0x20,0x20,0x20,0x20,0x2E,0x2E,0x20};  // char 177  T=

unsigned int Aff_buffer[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
char message[] = " DEFILEMENT MATRICE 8*8 ";
char var[] = {32, 49, 50, 72, 53, 55, 109, 110, 00};
char Apparence=0;

// ---RTC -----
char time[]="00:00:00";
char date[]="00/00/00"; 
unsigned char Heure_En_Cours ;

volatile unsigned char Msg[65];  // 64 cars + zero
char MinHour,MaxHour;
char PLM_Status=0;
unsigned int Kp;
unsigned char Repetition_Affichage_Texte=6;
unsigned char Rep=6;
unsigned char Lum=0;
unsigned int Tour=0;
unsigned int Speed=99;

const char *mes1 = "HELLO PAULO   ";
const char *mes2 = " paulfjujo 01 ";

unsigned char select_aff = 255; 

//volatile unsigned char Adresse_7bits;
unsigned char I2_Adresses_Devices[8];
unsigned char tmp[8]={0,0,0,0,0,0,0,0};

char Temp_DS18B20_A[32];

signed int kS;
signed int COR1; //,COR2;        // correctif temper en 1/1000 em de degre
unsigned int ADREP;   // adresse PIC EEPROM
signed int Q  ;
float FCOR1; //,FCOR2;
volatile signed int i2,j2,n2,m2,q2;
volatile int kL=0;
  
void I2C1_Write1ByteRegister(i2c1_address_t address, unsigned char reg, unsigned char data);

void BCD_To_Ascii(unsigned char cc,unsigned char * px);
unsigned char  Bcd2Dec( unsigned char v1);
unsigned char Dec2Bcd(unsigned char n);
 
void __delay_xSec(unsigned char N);
void Init_Timer4(void);         // 100mS ( avec 500Khz!
void TMR6_Init_500ms(char N);

void ecr_7219_def(Byte ad1, Byte dat1, Byte dat2 ) ;

 void Clear_12_Matrice(void);
 void Efface_Aff(void);
 void SPI_Write_To_12x7219(Byte adr, Byte d1, Byte d2,Byte d3, Byte d4, Byte d5,Byte d6,Byte d7,Byte d8,Byte d9,Byte d10,Byte d11,Byte d12) ;
 void SPI_Write_To_7219(Byte adr, Byte d1) ;
 void SPI_WRITE_Byte(Byte x) ;
 void Affiche_12_Matrices_en_Texte_sur_Terminal(void);
 void  Organisation_Display_Matrice_on_Terminal(void);
 void UpDate_Trame(void);
 void New_Decalage_96bits_en_ASM_X(void); 

void DATAEE_WriteByte(int bAdd, unsigned char bData);
unsigned char DATAEE_ReadByte(int bAdd);
void Sauve_Float_To_Eeprom(unsigned int ad1,float Fv);
float  Read_Float_from_Eeprom(unsigned int Adresse) ;  
void Write_Msg_To_EEPROM(int addr, char length,  char *source);    
void Read_Msg_From_Eeprom( int debut, char * T);

void  Interrupt_Init(void)
{
    INTCON0bits.IPEN = 1;
    bool state = (unsigned char)  INTCON0bits.GIE;
    INTCON0bits.GIEH = 1; // dis high priority interrupts
    INTCON0bits.GIEL = 0; // dis low priority interrupts
    INTCON0bits.IPEN = 1; // Enable interrupt priority
   //  ___asm("BCF INTCON0,GIE");
    IVTLOCK = 0x55;
    IVTLOCK = 0xAA;
    IVTLOCKbits.IVTLOCKED = 0x00; // unlock IVT
    IVTBASEU = 0;
    IVTBASEH = 0;
    IVTBASEL = 8;
    IVTLOCK = 0x55;
    IVTLOCK = 0xAA;
    IVTLOCKbits.IVTLOCKED = 0x01; // lock IVT
    // Assign peripheral interrupt priority vectors
    IPR3bits.U1RXIP = 1;
    INTCON0bits.GIE= state;
}


void __interrupt(irq(IRQ_U1RX),high_priority) UART1_rx_vect_isr(void)
{
   static char cx;
  //  U1TXB='H';  // pour debugging only
  if ( (PIR3bits.U1RXIF==1) && (PIE3bits.U1RXIE ==1) )
  {   
      c1=U1RXB;
    // U1TXB='*'; // echo
     if ((c1==13) || (i1>UART1_RX_BUFFER_SIZE-1))
     { 
      Flag_Buffer1=1;
      Buffer1[i1]=0;
      Index1=i1;
      i1=0; 
     PIE3bits.U1RXIE =0;
     }
     else
     {
       Buffer1[i1]=c1;
       i1++;
       Index1=i1;
      } 
   } 
}


void __interrupt(irq(IRQ_TMR1),high_priority)TMR1_ISR(void)
{        
  if (  (PIR4bits.TMR1IF==1) && ( PIE4bits.TMR1IE==1) )
  {
      if ( Cpt1 < 1)   // x 100ms at 500Khz
      {
      T1CONbits.TMR1ON=0;// stop comptage  timer1
      PIE4bits.TMR1IE=0;
      Drapeaux.Tmr1_Elapsed=1;
      }
      else
      {
       Cpt1--;
      }
      // 100mS  avec prescaler =1/2  et bascule  1/2
      TMR1H         = 0xCF;  // 53036
      TMR1L         = 0x2C;
      Flag_Timer1=1;
      PIR4bits.TMR1IF=0;
  }
}  


void __interrupt(irq(IRQ_INT0),high_priority) INT0_ISR(void)
{
    if ( ( PIR1bits.INT0IF ==1) && ( PIE1bits.INT0IE==1))
    {
      //  U1TXB='?';
        __delay_ms(2);
        if (RB0==1)
        {
        Flag_RB0=1;
         // Led_V=1;Led_R=0; Led_B=0;
         // Led_Verte_ON
         }
        PIR1bits.INT0IF =0;
      //  PIE1bits.INT0IE=0;
    }
    Count_RB0++;
  }

// Conversion du code BCD en chiffre decimal
 unsigned char  Bcd2Dec( unsigned char  val)
{
 return ( (val>>4)*10 + (val%16) );
}

 void BCD_To_Ascii( unsigned char  cc, unsigned char * px)
 {
 *(px)=(cc>>4) + 48;
 *(px+1)=(cc & 0x0F) +48;
 *(px+2)=0;
 }

unsigned char Dec2Bcd(uint8_t n)
{
 return (n / 10 * 16 +  n % 10);
}


void Hardware_Init(void)
{
    LATA = 0x00;
    LATB = 0xFF;
    LATC = 0xFF;
    ANSELC = 0x00;
    ANSELB = 0x00;
    ANSELA = 0x00;

    TRISA = 0x00;   // Def_Pins_PORTA;  //0x00
    TRISB = 0xFF;
    TRISC = 0b10000000;
    
    RC5PPS=0;     
    SPI_CS = 1;
    SPI_CLOCK = 0;
    SPI_DOUT = 0;
    
    WPUE = 0x00;
    WPUB = 0xFF;
    WPUA = 0xFC;
    WPUC = 0xFF;  
    
    RA0PPS=0;
    RA1PPS=0;
    RA2PPS=0;
    RA4PPS=0;
    Led_Rouge_Dir=0;
    Led_Rouge=OFF;

   // RxyI2C registers
    RB1I2C = 0x00;
    RB2I2C = 0x00;
    RB0PPS=0;
    RB1PPS=0;
    RB2PPS=0;
    RB3PPS=0;
    RB4PPS=0;
    RB5PPS=0;
    RB6PPS=0;
    RB7PPS=0;
    
    RTC_Forcee_Dir =1 ;  //RB2
    Bavard_Forcee_Dir=1 ;//RB1

   // ODx registers
    ODCONA = 0x07;  //  0x07 => open drain sur RA0,RA1,RA2  OWS sensor
    ODCONB = 0x07;
    ODCONC = 0x18;  // I2C 
   
  //  SLRCONx registers
    SLRCONA = 0xFF;
    SLRCONB = 0x80; //0xFF;
    SLRCONC = 0xFF;

   // INLVLx registers
    INLVLA = 0xFF;
    INLVLB = 0xFF;
    INLVLC = 0xFF;
    INLVLE = 0x08;
    
    IOCAF=0;
    IOCAN=0;
    IOCAP=0;

    IOCBF=0;
    IOCBN=0;
    IOCBP=0;
    
    IOCCF=0;
    IOCCN=0;
    IOCCP=0;
      
	// I2C1
    RC3PPS = 0x21;      //RC3->I2C1:SCL1;    
    RC4PPS = 0x22;      //RC4->I2C1:SDA1; 
    // UART1
    RC6PPS = 0x13;      //RC6->UART1:TX1;    
    U1RXPPS = 0x17;     //RC7->UART1:RX1;    
    I2C1SCLPPS = 0x13;  //RC3->I2C1:SCL1;  
    I2C1SDAPPS = 0x14;  //RC4->I2C1:SDA1;     
}

// -------------  I2C --------------------------------

void Init_I2C (void)
{   
    I2C1CLK    = 0x03;      // I2C1 Clock Selection Register, MFINTOSC 500kHz ?? 100kHz ??  // doc p. 581
  // 2-04-2023  probleme maxi pCF SLC =100KHz
  //  I2C1CLK    = 0x06;    ///0110	 TMR2 post scaled output	42Khz theorique
  // SQA mesure  18.00+11.76=29.76S -> 33.6Khz ?? why ?
    I2C1CON0   = 0x04;      // I2C1 Control Register 0, Master mode, 7-bit Address  // doc p.577
    I2C1CON1   = 0x80;      // I2C1 Control Register 1, Acknowledge value transmitted after received data 
                            //(when I2CCNT=0) : 1 = NACK     (Not ACKnowledge)  // doc p.579
    I2C1CON2   = 0x00;      // I2C1 Control Register 2, envoi Start non auto, SDAHT 300ns hold time, BFRET 8 i2c clock pulses  // doc p.580
    I2C1CNT = 0;
 //   I2C1CON2bits.FME=1;
    I2C1CON2bits.ABD=0; //  ADB=0; // Transmitted Address data is loaded from the I2CxADB0/1 registers.
     // I2C1ADB1   = 0x3C;      //0x3C adresse bus I2C mini oled SSD1306
    I2C1ADB1   = 0x20 ;   //LCD_ADDR;   // LCD 2x16 avec PCF8754
    I2C1PIRbits.PCIF = 0;  // clear STOP bit flag
  //  I2C1CON2bits.ABD=1;   
    I2C1CON0bits.EN=0;   // i2c1 OFF   
}


bool I2C1_DevicePresent(int16_t Address)
{
I2C1PIRbits.PCIF = 0;                // clear STOP bit flag
I2C1ADB1 = Address;                  // load slave Addr and R/W
I2C1CNT = 0;
I2C1CON0bits.S = 1;                  // send START + Addr
while (I2C1PIRbits.PCIF == 0);       // wait for STOP
return !I2C1CON1bits.ACKSTAT;
}

void Test_Presence_I2C_devices()
{
 int i,j;
 txt=&TEXTE[0]; 
 //*(txt)=0;
// I2C1CON2 = 0x00;  // <- OK
I2C1CON2bits.ABD=0; //  ADB=0; // Transmitted Address data is loaded from the I2CxADB0/1 registers.
I2C1CON0bits.EN = 1;
for (i=2; i<252; i=i+2)
{
if (I2C1_DevicePresent(i))
{
k=i>>1;
sprintf(txt," @ decimal #%4u  soit @Device 7bits = 0X%02X ",i,k);
//Print(txt);
switch (k)
{
case 0x20:// de base + 7 autres
case 0x21:
case 0x22:
case 0x23:
    //...etc 
case 0x27:
   strcat(txt," PCF8754 for LCD 2x16cars"); 
   break;
case 0x28:
case 0x29:
case 0x2A:
// case etc ..
strConstRamCpy(CRam1,"PCF8574 8bits IO" );  
j=strlen(txt);
strcpy(txt+j,CRam1);
//txt=strcat(txt,CRam1);// de base + 7 autres
break;
case 0x37:
     strcat(txt,"LCD 2119 2x16cars"); // de base + 7 autres
break;
case 0x38:
case 0x39:
case 0x3A:
case 0x3B:
// case etc ..
strcat(txt,"PCF8574A 8bits I/O"); // de base + 7 autres
break;
case 0x3C:
strcat(txt,"OLED SSD1306");
break;
case 0x57:
strcat(txt,"EEPROM 512bytes");
break;
case 0x68:
strcat(txt,"RTC DS3231");
break;
default:
strcat(txt,"non recens");
break;
}
Print(txt);CRLF1();
}
}
I2C1CON0bits.EN = 0;
//I2C1CON2 = 0x18;
I2C1CON2bits.ABD=1;
CRLF1();
}

//------------------------------------------------------
void __delay_xSec(unsigned char N)
{
static int i2;  
for (i2=0;i2<N;i2++)  __delay_ms(1000);
}

void Clear_12_Matrice(void)
{  int i;
  for (i=0;i<8;i++)
   {
    SPI_Write_To_12x7219(i+1,0,0,0,0,0,0,0,0,0,0,0,0);
    __delay_us(20);
   }
  SPI_Write_To_12x7219(0,0,0,0,0,0,0,0,0,0,0,0,0);
   SPI_Write_To_12x7219(REG_INTENSITY, 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00); //- intensity  minima

  }


void Init_12_Module_Max7219_8x8()     // 12 matrices
 {
  __delay_ms(100);
   SPI_CS=1;
   SPI_Write_To_12x7219(REG_DISPLAY_TEST, 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00); // pas de test - no test
   SPI_Write_To_12x7219(REG_SCAN_LIMIT ,   0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07);
   SPI_Write_To_12x7219(REG_DECODE,       0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00); //pas de decodage - no decode
   //intensit - intensity  minima
   SPI_Write_To_12x7219(REG_INTENSITY, 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00); //- intensity  minima
  SPI_Write_To_12x7219(REG_SHUTDOWN,      0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01); // normal operation
  __delay_ms(10);
 }

void SPI_Write_To_12x7219(Byte adr1, Byte d1, Byte d2,Byte d3, Byte d4, Byte d5,Byte d6,Byte d7,Byte d8,Byte d9,Byte d10,Byte d11,Byte d12)
  {   SPI_CS=0;
   __delay_us(5);
          
     SPI_WRITE_Byte(adr1);  SPI_WRITE_Byte(d12);  Dx
     SPI_WRITE_Byte(adr1);  SPI_WRITE_Byte(d11);  Dx
     SPI_WRITE_Byte(adr1);  SPI_WRITE_Byte(d10);  Dx
     SPI_WRITE_Byte(adr1);  SPI_WRITE_Byte(d9);   Dx
   
     SPI_WRITE_Byte(adr1);  SPI_WRITE_Byte(d8);   Dx
     SPI_WRITE_Byte(adr1);  SPI_WRITE_Byte(d7);   Dx
     SPI_WRITE_Byte(adr1);  SPI_WRITE_Byte(d6);   Dx
     SPI_WRITE_Byte(adr1);  SPI_WRITE_Byte(d5);   Dx

     SPI_WRITE_Byte(adr1);  SPI_WRITE_Byte(d4);   Dx
     SPI_WRITE_Byte(adr1);   SPI_WRITE_Byte(d3);  Dx
     SPI_WRITE_Byte(adr1);  SPI_WRITE_Byte(d2);   Dx
     SPI_WRITE_Byte(adr1);  SPI_WRITE_Byte(d1);   Dx
  __delay_us(5);
  SPI_CS=1;
}

 void SPI_Write_To_7219(Byte adr1, Byte d1)
  {
   SPI_CLOCK=0;
   Dx
   SPI_DOUT=0;
   Dx
   SPI_CS=0;
   Dx
   SPI_WRITE_Byte(adr1);
   Dx
   SPI_WRITE_Byte(d1);
   Dx
   SPI_CS=1;
   Dx
   SPI_CS=0;
   Dx
   SPI_CLOCK=0;
   Dx
   SPI_DOUT=0;
   Dx
}


void SPI_WRITE_Byte(Byte x1)
 {
 int i;
 Byte cc;
 SPI_CLOCK=0;
 cc=x1;
 //SPI_DOUT=0;

 for (i=0;i<8;i++)
 {
  if ((cc & 0x80)==0x80)
   SPI_DOUT=1;
   else
   SPI_DOUT=0;
  __delay_us(5);
  cc=cc<<1;
  SPI_CLOCK=1;
  __delay_us(5);
  SPI_CLOCK=0;
   __delay_us(5);
  }
 }


 void remplis_buffer_with_string(char *pp)
 {
 int ix,j,k,m;
 unsigned char  c1,cx;
 unsigned char *Dp;
 Dp=OFFSET;
  j=0;
  m=0;
  for (j=0;j<12;j++)
  {
   c1=*(pp+j);
   switch (c1)
   {

     case '' : //176
           for (ix=0;ix<8;ix++)
           {
           cx= Lettre_Degre_C[ix];
           m= (j*8 )+ ix;
           *(Dp+m)=cx;
           }
            break;
     case  177 :
        for (ix=0;ix<8;ix++)
         {
          cx= Lettre_TemperEgal[ix];
          m= (j*8 )+ ix;
          *(Dp+m)=cx;
         }
         break;
      default :
         if (c1==';')c1=' '  ;
         k=c1*8;
        for (ix=0;ix<8;ix++)
        {
          cx= fonte_8x8_H[k+ix];
          m= (j*8 )+ ix;
          *(Dp+m)=cx;
        }
        break;
     } //switch  
  }  // for j
 }

 
char * Bin2Asc(unsigned char untel)
{
 unsigned char masque=0x80; //1000 0000
 int indice=0;
 static char Binary[]="00000000";
 
 while (indice<8)
 {
   if (Apparence==0)
   {
   if ((untel & masque)>0)
      Binary[indice]='1';
       else
       Binary[indice]='0'; // si resultat du AND >0 on range '1' ( ou 0x49)
    }
    else
    {
       if ((untel & masque)>0)
      Binary[indice]='*';
       else
       Binary[indice]='.'; // si resultat du AND >0 on range '1' ( ou 0x49)
     }
    masque = masque >> 1; // divise par 2
    indice++;
  }
  Binary[8]=0; // string terminator
  return &Binary[0];
}


void Affiche_12_Matrices_en_Texte_sur_Terminal(void)
 {  int j;
    pB=OFFSET;
    txt=&TEXTE[0];
    CRLF1();
    for (j=0;j<8;j++)
    {
    Print( Bin2Asc( *(pB+j)));   Print( Bin2Asc( *(pB+j+8)));
    Print( Bin2Asc( *(pB+j+16))); Print( Bin2Asc( *(pB+j+24)));
    Print( Bin2Asc( *(pB+j+32))); Print( Bin2Asc( *(pB+j+40)));
    Print( Bin2Asc( *(pB+j+48))); Print( Bin2Asc( *(pB+j+56)));
    Print( Bin2Asc( *(pB+j+64))); Print( Bin2Asc( *(pB+j+72)));
    Print( Bin2Asc( *(pB+j+80))); Print( Bin2Asc( *(pB+j+88)));
    CRLF1();
     }
  }


void  Organisation_Display_Matrice_on_Terminal(void)
{
    int jb;
    pB=OFFSET;
    txt=&TEXTE[0];
    sprintf(txt,"\r\n pB=OFFSET=% 5d soit  0%4xH \r\n",pB,pB);
   Print(txt);
    CRLF1();
    for (jb=0;jb<8;jb++)
    {
    sprintf(txt,"   %03d      %03d      %03d      %03d      %03d      %03d      %03d    %03d    %03d      %03d      %03d    %03d \r\n",
      jb,jb+8,jb+16,jb+24,jb+32,jb+40,jb+48,jb+56,jb+64,jb+72,jb+80,jb+88);
     Print(txt);
     }
   __delay_ms(250);
   CRLF1();
}


void _Affiche_96bits_12_Matrices_H(void)
{ // 03-03-2020
 int j=0;
 // reverse WAY ! connecteur  droite
 // In  Out Marks on Front Side (compoenent)
  pB=OFFSET;
  for (j=0;j<8;j++)
     {
         SPI_Write_To_12x7219(j+1,
        *(pB+88+j),*(pB+80+j),*(pB+72+j) ,*(pB+64+j),
        *(pB+56+j) ,*(pB+48+j),*(pB+40+j),*(pB+32+j),
        *(pB+24+j) ,*(pB+16+j),*(pB+8+j) ,*(pB+j));
    }
 }


 void UpDate_Trame(void)
 {  // 17.04.2020  remplacemnt ' '  separateur de champ ';'
   int k ;
 //  GIE_bit=0;
   txt=&TEXTE[0];
  // if (  (Repetition_Affichage_Texte==0)  &&  (Drapeaux.First_Run==1) )
  if  (Repetition_Affichage_Texte==0) // &&  (Drapeaux.First_Run==1) )
   {
   for (k=0;k<96;k++) TEXTE[k]=0;
   txt=&TEXTE[0];  // initialise pointeur txt sur debut de TEXTE
   pT =&TEXTE[0];
   *(pT)=32;       // 1er element de TEXTE[0]= espace
   //--- Time     12:36:26   8cars + zero --------------
   strncpy(pT+1,time,9); // rajoute Time + zero
   if(Bavard==1)  { CPrint("Time=");Print(pT);PrintChar(';');}
   *(pT+9)=' '; //
   pJ=pT+10; // pointe sur index suivant
  // --------------------------------------------- 
   strConstRamCpy(pJ,JourSemaine[jS]);   // rajoute string jour de la semaine (jour=5 cars + zero !)
   k=strlen(pJ);
   if(Bavard==1)  { CPrint("jS=");Print(pJ);PrintChar(';');}
   *(pJ+k)=32;   // remplace le zero en fin de string! par espace

 //-------------------------------------------------- 
   pD=pJ+k+1;
   *(pD)=*(date);  // rajoute 1er digit du jour (date)
   *(pD+1)=*(date+1); // rajoute 2em digit du jour (date)
   *(pD+2)=0;// rajoute espace
    if(Bavard==1)  { CPrint("date=");Print(pD);PrintChar(';');}
    *(pD+2)=32;
   //------------------------------------------------
   pM=pD+3;     // initailise pointeur Mois sur index suivant
  // Month= Bcd2Dec(mois);
   strConstRamCpy(pM,Douze_Mois[Month]); // Month=01  12  string sur 7 cars + Zero
   k=strlen(pM);
   if(Bavard==1)  {CPrint("Mois="); Print(pM);PrintChar(';');}
   //------------------------------------------------
   *(pM+k)=32;   // remplace le zero par espace !
   pI=pM+k; // ajuste pointeur sur temperature interieure
   k=strlen(Temp_DS18B20_A);  // resultat mesure de temperature DS18B20 en ascii
   strncpy(pI,Temp_DS18B20_A,k); // rajoute temperature (ex:+23.25C)
   k=strlen(pI);
   *(pI+k)=32; 
   *(pI+k+1)=0;// terminateur de string
    if(Bavard==1)  {CPrint("Ti="); Print(pI);CRLF1();}
   *(Msg)=0;
    kL=strlen(txt);
   }
   else
   {
     *(Msg+63)=0;  // longuer maxi du message
     txt= &TEXTE[0];
     for (k=0;k<96;k++)*(txt)=0;
     pT=&TEXTE[0];
     *(pT)=32;
    //Time     12:36:26
     strncpy(pT+1,time,9);  // y compris zero terminateur
     if(Bavard==1){ Print(pT+1);CRLF1();}   
     k=strlen(pT);
     pT=txt+k;
    *(pT)=32;
     k= strlen(Msg);
     strncpy(pT+1,Msg,k);
     *(pT+1+k)=0;
     kL=strlen(txt);
     if(Bavard==1){ Print(txt); CRLF1();}
     }
   if (kL>95) kL=95;
   *(txt+96)=0; //limite maxi longueur posible
 }

 //----- EEPROM PIC --------------------------------------
 
void DATAEE_WriteByte(int bAdd, unsigned char bData)
{
    unsigned char GIEBitValue = INTCON0bits.GIE;

    NVMADRH = (unsigned char)((bAdd >> 8) & 0x03);
    NVMADRL = (unsigned char)(bAdd & 0xFF);
    NVMDAT = bData;
    NVMCON1bits.NVMREG = 0;
    NVMCON1bits.WREN = 1;
    INTCON0bits.GIE = 0;     // Disable interrupts
    NVMCON2 = 0x55;
    NVMCON2 = 0xAA;
    NVMCON1bits.WR = 1;
    // Wait for write to complete
    while (NVMCON1bits.WR)
    {
         __asm("NOP");
    }

    NVMCON1bits.WREN = 0;
    INTCON0bits.GIE = GIEBitValue;   // restore interrupt enable
}

unsigned char DATAEE_ReadByte( int bAdd)
{
    NVMADRH = (unsigned char)((bAdd >> 8) & 0x03);
    NVMADRL = (unsigned char)(bAdd & 0xFF);
    NVMCON1bits.NVMREG = 0;
    NVMCON1bits.RD = 1;
    __asm("NOP");  // NOPs may be required for latency at high frequencies
    __asm("NOP");
    __asm("NOP");
     __asm("NOP");
    return (NVMDAT);
} 


 float  Read_Float_from_Eeprom(unsigned int Adresse) 
   { int j; 
     unsigned char *Pt;
     float Rf;
     Pt=&Rf;
     for (j=0;j<4;j++) *(Pt+j)=DATAEE_ReadByte(Adresse+j);   
     return Rf;
   }  
 
  
void Sauve_Float_To_Eeprom(unsigned int ad1,float Fv)
{  unsigned int i;
   static unsigned char *pt;
   if (INTCON0bits.GIE==0)    Status_GIE_Bit=1; 
   INTCON0bits.GIE=0;
    // sprintf(CRam1," Sauve %5.2f value at adr=%04x\r\n",Fv,ad1);
  //  Print(CRam1);
    pt=&Fv;
   for (i=0;i<4;i++)
    {  
     // PrintChar(i+48);PrintChar(' ');
	  DATAEE_WriteByte(ad1+i,*(pt+i));
      __delay_ms(25);
    }
   if (Status_GIE_Bit) INTCON0bits.GIE=1; 
}   
  

void Write_Msg_To_EEPROM( int addr,char longueur,char *source)       // not used !
{
  unsigned char *ptr;
  unsigned int i1;
  i1=0;
  ptr = source;
  do
  {
   DATAEE_WriteByte(addr+i1,*(ptr));
     if((*ptr)==0) break;
   __delay_ms(20);
   ptr++;
   i1++;
  }while (i1<longueur);
}  


void Read_Msg_From_Eeprom(  int debut,  char * T)
{
 int i1;
 int k1;
 char Ce;
  i1=0;
  do
  {
  Ce =  DATAEE_ReadByte(debut+i1);
  //U1TXB=Ce;
  *(T+i1)=Ce;
  if ( Ce==0) break;
  __delay_ms(20);
  i1++;
   }
  while (i1<32) ;
  *(T+i1)=0;
 }
  
void New_decalage_96bits_en_ASM_X()
  { //rev 20/05/2023
   __asm("NOP"); 
   __asm("movffl WREG,_save_w ");
   __asm("movffl BSR,_save_bsr ");
   __asm("movlb 0");                      // modif 29/05/2023
   __asm("bcf STATUS,0");
   __asm("rlcf _temps+88,F");
   __asm("rlcf _temps+80,F");
   __asm("rlcf _temps+72,F");
   __asm("rlcf _temps+64,F");
   __asm("rlcf _temps+56,F");
   __asm("rlcf _temps+48,F");
   __asm("rlcf _temps+40,F");
   __asm("rlcf _temps+32,F");
   __asm("rlcf _temps+24,F");
   __asm("rlcf _temps+16,F");
   __asm("rlcf _temps+8,F");
   __asm("rlcf _temps+0,F");
   __asm(" bcf STATUS,0");
   __asm("rlcf _temps+89,F");
   __asm("rlcf _temps+81,F");
   __asm("rlcf _temps+73,F");
   __asm("rlcf _temps+65,F");
   __asm("rlcf _temps+57,F");
   __asm("rlcf _temps+49,F");
   __asm("rlcf _temps+41,F");
   __asm("rlcf _temps+33,F");
   __asm("rlcf _temps+25,F");
   __asm("rlcf _temps+17,F");
   __asm("rlcf _temps+9,F");
   __asm("rlcf _temps+1,F");
   __asm(" bcf STATUS,0");
   __asm("rlcf _temps+90,F");
   __asm("rlcf _temps+82,F");
   __asm("rlcf _temps+74,F");
   __asm("rlcf _temps+66,F");
   __asm("rlcf _temps+58,F");
   __asm("rlcf _temps+50,F");
   __asm("rlcf _temps+42,F");
   __asm("rlcf _temps+34,F");
   __asm("rlcf _temps+26,F");
   __asm("rlcf _temps+18,F");
   __asm("rlcf _temps+10,F");
   __asm("rlcf _temps+2,F");
   __asm(" bcf STATUS,0");
   __asm("rlcf _temps+91,F");
   __asm("rlcf _temps+83,F");
   __asm("rlcf _temps+75,F");
   __asm("rlcf _temps+67,F");
   __asm("rlcf _temps+59,F");
   __asm("rlcf _temps+51,F");
   __asm("rlcf _temps+43,F");
   __asm("rlcf _temps+35,F");
   __asm("rlcf _temps+27,F");
   __asm("rlcf _temps+19,F");
   __asm("rlcf _temps+11,F");
   __asm("rlcf _temps+3,F");
   __asm(" bcf STATUS,0");
   __asm("rlcf _temps+92,F");
   __asm("rlcf _temps+84,F");
   __asm("rlcf _temps+76,F");
   __asm("rlcf _temps+68,F");
   __asm("rlcf _temps+60,F");
   __asm("rlcf _temps+52,F");
   __asm("rlcf _temps+44,F");
   __asm("rlcf _temps+36,F");
   __asm("rlcf _temps+28,F");
   __asm("rlcf _temps+20,F");
   __asm("rlcf _temps+12,F");
   __asm("rlcf _temps+4,F");
   __asm(" bcf STATUS,0");
   __asm("rlcf _temps+93,F");
   __asm("rlcf _temps+85,F");
   __asm("rlcf _temps+77,F");
   __asm("rlcf _temps+69,F");
   __asm("rlcf _temps+61,F");
   __asm("rlcf _temps+53,F");
   __asm("rlcf _temps+45,F");
   __asm("rlcf _temps+37,F");
   __asm("rlcf _temps+29,F");
   __asm("rlcf _temps+21,F");
   __asm("rlcf _temps+13,F");
   __asm("rlcf _temps+5,F");
   __asm(" bcf STATUS,0");
   __asm("rlcf _temps+94,F");
   __asm("rlcf _temps+86,F");
   __asm("rlcf _temps+78,F");
   __asm("rlcf _temps+70,F");
   __asm("rlcf _temps+62,F");
   __asm("rlcf _temps+54,F");
   __asm("rlcf _temps+46,F");
   __asm("rlcf _temps+38,F");
   __asm("rlcf _temps+30,F");
   __asm("rlcf _temps+22,F");
   __asm("rlcf _temps+14,F");
   __asm("rlcf _temps+6,F");
   __asm(" bcf STATUS,0");
   __asm("rlcf _temps+95,F");
   __asm("rlcf _temps+87,F");
   __asm("rlcf _temps+79,F");
   __asm("rlcf _temps+71,F");
   __asm("rlcf _temps+63,F");
   __asm("rlcf _temps+55,F");
   __asm("rlcf _temps+47,F");
   __asm("rlcf _temps+39,F");
   __asm("rlcf _temps+31,F");
   __asm("rlcf _temps+23,F");
   __asm("rlcf _temps+15,F");
   __asm("rlcf _temps+7,F");
   __asm(" movffl _save_bsr,BSR ");
   __asm("movffl _save_w,WREG ");
  }

 // ************************************************************
    
void main(void)
{

    OSCCON1 = 0x60;
    OSCCON3 = 0x00;
    OSCEN = 0x00;
    OSCFRQ = 0x08;  // 64Mhz
    OSCTUNE = 0x00;
    
     __delay_ms(200);
     
     GIE=0;
    
     IOCIE=0;
     IOCAP=0;
     IOCAN=0;
     IOCAF=0;
     IOCCP=0;
     IOCCN=0;
     IOCCF=0;
       
    PIE0bits.IOCIE=0;
    PIE1bits.INT0IE=0;
    PIR0bits.IOCIF=0;
    PIR1bits.INT0IF=0; 
   
    Hardware_Init();
    
    UART1_Init();
    __delay_ms(100);
    CRLF1();
    for (i=0;i<24;i++)temps[i]=0;  
    for (i=0;i<64;i++)Msg[i]=0;
    for (i=0;i<sizeof(TEXTE);i++) TEXTE[i]=0;
    txt=&TEXTE[0];
    
    CPrint(" Presentation :");
    for (i=0;i<10;i++)
    {
     CPrint(Messages[i]);   
    }
    CRLF1();
    sprintf(txt," Compile le %s a %s UTC\r\n avec version XC8 :  %d et PACK %s\r\n", __DATE__, __TIME__,__XC8_VERSION,PACK);
    Print(txt);
    CRLF1();
    
     Drapeaux.First_Run=1;
    if ( PORTBbits.RB1==0) DATAEE_WriteByte(0x03F0,0xFF);
    for(i=0;i<127;i++) CRam1[i]=0;
    cx=DATAEE_ReadByte(0x03F0);
    if (cx==0xFF)
    {   
     px=&CRam1[0];
     CPrint(" Cree parametrage en Eeeprom PIC : 1");    
     strConstRamCpy(CRam1, "Horloge 12 MatricesH 8x8 2023\r\n");
     *(CRam1+31)=0;
     Write_Msg_To_EEPROM(0x0000,32,&CRam1[0]); 
     U1TXB='2';
     strConstRamCpy(CRam1 ," 18F7K42,FOSC 64MHz,DS3231   \r\n");
     *(CRam1+31)=0;
      Write_Msg_To_EEPROM(0x0020,32,&CRam1[0]);
      U1TXB='3';
     strConstRamCpy(CRam1, "PLM=23:01\r\n");
     Write_Msg_To_EEPROM(0x0060,16,&CRam1[0]);
     U1TXB='4';
     strConstRamCpy(CRam1,"Speed=10\r\n");
     Write_Msg_To_EEPROM(0x0070,16,&CRam1[0]);
     U1TXB='5'; 
     strConstRamCpy(CRam1,"Rep=00\r\n");
     Write_Msg_To_EEPROM(0x0080,16,&CRam1[0]);
     U1TXB='6'; 
     strConstRamCpy(CRam1,"Lum=01\r\n");
     Write_Msg_To_EEPROM(0x0090,16,CRam1);
     U1TXB='7'; 
     strConstRamCpy(CRam1,"COR1=+001\r\n");
     Write_Msg_To_EEPROM(0x00A0,16,CRam1);
     U1TXB='8'; 
     DATAEE_WriteByte(0x03F0,99);
      CRLF1();
    }
  
   CPrint(" L'Eeprom du PIC est  pr-initialise directement par le code\r\n"); 
   txt=&TEXTE[0];
   CPrint(" ReLecture des parametres en  Eeprom\r\n");
   Read_Msg_From_Eeprom(0x0000,txt) ;  __delay_ms(20);
   Print(txt); 
   Read_Msg_From_Eeprom(0x0020,txt) ;  __delay_ms(20);
   Print(txt);CRLF1(); 
   txt=&TEXTE[0];
   // PLM
   Read_Msg_From_Eeprom(0x0060,txt) ; Print(txt);
   *(txt+6)=0;
   MaxHour=atoi(txt+4);
   *(txt+9)=0;
   MinHour=atoi(txt+7);
   __delay_ms(20);
   //Speed=xx
   txt=&TEXTE[0];
   Read_Msg_From_Eeprom(0x0070,txt) ; Print(txt);
   Speed= (*(txt+6)-48)*10;
   Speed= Speed +  (*(txt+7)-48);
   __delay_ms(20);
    // Rep=01
    Rep=0;
    txt=&TEXTE[0];
    Read_Msg_From_Eeprom(0x0080,txt) ;  Print(txt);
    Rep= (*(txt+4)-48)*10;
    Rep= Rep +  (*(txt+5)-48);
    Repetition_Affichage_Texte=Rep;
    __delay_ms(20);
    // Lum  Luminosit
   Lum=0;
   txt=&TEXTE[0];
   Read_Msg_From_Eeprom(0x0090,txt) ;  Print(txt);
   Lum= (*(txt+4)-48)*10;
   Lum= Lum +  (*(txt+5)-48);
   Lum=Lum & 0x0F;
    __delay_ms(20);

   COR1=0;
   txt=&TEXTE[0];
   Read_Msg_From_Eeprom(0x00A0,txt) ;  Print(txt);
   COR1= (*(txt+6)-48)*100;
   COR1= COR1+  (*(txt+7)-48)*10;
   COR1= COR1+  (*(txt+8)-48);
   if (*(txt+5)=='-')COR1=-COR1;
   if ((COR1<-300)|| (COR1>300)) COR1=0;
   FCOR1=(float)COR1/100.0; 
   CRLF1();
    __delay_ms(20);
        
    
    CPrint(" Init_I2C()  100Khz;\r\n");
    Init_I2C(); //SCLK=  500Khz / 5 = 100Khz
    CPrint(" Test presence devices sur Bus I2C1\r\n");
    Test_Presence_I2C_devices();
    CRLF1();

    CPrint(" #1 Active sortie RTC SQW=1Hz: \r\n");
    CPrint(" GO\r\n");
    // set SQW output  Start oscillateur
    tmp[0]=0x40; // data 
    I2C1_Write1ByteRegister(DS3231_ADDR,0x0E, tmp[0]);
    CPrint(" ok\r\n");
    __delay_ms(100);

    CPrint(" ATTENTION : Possibilit de forage init RTC inhibe pendant les tests\r\n");
    if(RTC_Forcee==0)    // RB2 input
     {
        CPrint( " Etat pin RB2 = " );
        if ( (PORTB & 0x04)==0x04) PrintChar('1'); else PrintChar('0');
        CRLF1();
        Forcage_RTC();
    }
     __delay_ms(1000);
      
    Apparence=1;
    CPrint(" Re-Lecture et affichage (si bavard=1)des 8 registres  RTC DS3231 \r\n");
    j=0;
   // Bavard=0;
    do
    {
       if (Bavard==1)
       {    
            CPrint(" Registre #");
            PrintChar(j+48);
            PrintChar(9);
            cx=Lecture_Affichage_Registre_DS3231(j,1); //parametre 0=sans affichage,1=avec 
            CRLF1();
        }
        else
         cx=Lecture_Affichage_Registre_DS3231(j,0); // sans affichage 
        j++;
    }
    while(j<8) ;
    CRLF1();
    Print_Date_Complete();CRLF1();
    __delay_ms(1000);
    
    CPrint(" Config et Init One Wire bus pour capteur DS18B20 en RA0\r\n");
    onewireInit_X();  
    F1= getTemperature1();
   // F1=-10.56;
    sprintf(txt," temperature Amb. =%5.2f%cC",F1,176);
    Print(txt);CRLF1();  
    F1=F1+(float)COR1/100.0;
    sprintf(Temp_DS18B20_A," %5.2f%c",F1,176);
    //Print(Temp_DS18B20_A);CRLF1();
    CRLF1();
    __delay_ms(1000);
    
    
    //===============  TEST     UpDate_Trame();=============================
   Drapeaux.First_Run=1;
   Repetition_Affichage_Texte=0;
   k=0;
   m2=0;
   p1=0;
   Kp=0;
   pB=OFFSET;
   
   CPrint(" Test Update()\r\n");
   txt=&TEXTE[0];
   UpDate_Trame();
   kL=strlen(txt); // logueur totale de la chaine  afficher sur les Max72129
   p2=txt;           // p2 pointe AUSSi sur le debut de TEXTE[]
   Print(p2); CRLF1();
   sprintf(CRam1," Long Trame = %5d  \r\n",kL);
   Print(CRam1);CRLF1();
   remplis_buffer_with_string(p2);
   CPrint(" remplis buffer with string TEXTE \r\n");
   Print(txt);
   CRLF1();
  
   //=================================================
   // SPI bit bang pour pilotage 12 Max7219 
   // Matrice 8x8 ype H  Reverse (connecteur  droite) ==
   k=0;
   SPI_CLOCK=0;
   SPI_DOUT=0;
   SPI_CS=1;
   CPrint(" Bit Bang Soft SPI  RC2=Clk ,RC1=Dout  RC0=CS -> Max7219:\r\n" )  ;
   CPrint(" Init Matrices MAX7219 \r\n" )  ;
   Init_12_Module_Max7219_8x8();
   __delay_xSec(1);

   CPrint(" Clear Matrices MAX7219 \r\n" )  ;
   Clear_12_Matrice() ;
   CRLF1();
   SPI_CS=1;
   CRLF1();
   CPrint(" Buffer d'affichage Buffer depuis <OFFSET=0x0020h> (bank0) 24 longs 32bits ! \r\n");
  
   CPrint(" Ajuste Luminosit  MAX7219 au minima \r\n" )  ;
   SPI_Write_To_12x7219(REG_INTENSITY, 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
   pB=OFFSET; // pointe sur 3x8 long 32 bits soit 8 lignes de 12 matrices de 8 leds ( 96 leds par ligne)
   // Entree Module 4 Max7219 --> connecteur  droite
   for(j=0;j<8;j++)    // 8 lignes                
   {  SPI_Write_To_12x7219(j+1,
        *(pB+88+j),*(pB+80+j), *(pB+72+j) ,*(pB+64+j),
        *(pB+56+j) ,*(pB+48+j),*(pB+40+j) ,*(pB+32+j),
        *(pB+24+j) ,*(pB+16+j),*(pB+8+j)  ,*(pB+j));
         __delay_ms(1);
    }
   CRLF1();
  
    Apparence=1;
    Bavard=1;
    CRLF1();
     strConstRamCpy(CRam1,"            ");
    remplis_buffer_with_string(CRam1);
    _Affiche_96bits_12_Matrices_H();
    CPrint(" TEXTE to display : ");Print(txt);CRLF1();
    j2=0;
    n2=0;
    m2=0;
   
   k=0;
   m2=0;
   p1=0;
   Kp=0;
   pB=OFFSET;
   p2=txt;
   Print(p2); CRLF1();
   sprintf(CRam1," Long Trame = %5d  \r\n",kL);
   Print(CRam1);
   remplis_buffer_with_string(p2);

   //-----------------------------------
 
 j2=0; // pixel position H
 m2=0; // caractere position dans le message de longur kL (<96 caracteres)
 n2=0;
 Tour=0;
 CPrint(" affiche nom de l'application\r\n");
 strConstRamCpy(Msg,Project);
 Repetition_Affichage_Texte=1;
 //Drapeaux.Once=0;

  txt=&TEXTE[0];
  UpDate_Trame();
  Bavard=0;
  CRLF1();
  kL=strlen(txt);
  p2=&txt[0];
  
  CPrint(" Init Interrupt  UART RX \r\n");
   
   IPR3bits.U1RXIP=1;
   IPR4bits.TMR1IP=1;
   PIE3bits.U1RXIE=1;
   T1CONbits.TMR1ON = 0;
   PIE1bits.INT0IE = 0;          // Enable Peripheral interrupt
   PIE4bits.TMR1IE=0;
   INTCON0bits.GIE = 1;         // Enable Global interrupt


 // ===============  BOUCLE PRINCIPALE  ===================================
do
{
   RAZ_UART1_Buffer1();
   // lecture capteur OWS DS18B20  Temp A
   F1= getTemperature1();
   F1=F1+(float)COR1/100.0;
   sprintf(Temp_DS18B20_A," %5.2f%c",F1,176);
      // Print(Temp_DS18B20_A); PrintChar(9);
   Display_Date_Time(0) ;   // si param=1 => avec affichage sur terminal !
   // --------------- recadrage affichage -----------   
   if (j2>7)  // modulo 8 pixels , soit 1 char
   {
     j2=0;
     if(m2>kL)
     {
     if(Bavard_Forcee==0) { Print(txt);CRLF1();}
     if (Repetition_Affichage_Texte>0)
      {
        Repetition_Affichage_Texte--;
       }
       m2=0;
       txt= &TEXTE[0];
       p2=txt;
       for(i2=0;i2<12;i2++) Aff_Buffer[i2]=*(p2+i2);
       
     }  
     else
     {       
      // decalage fenetre de 12 cars
      // rev 07-04-2020
      n2=kL-m2+1;
      if (m2<(kL-12))
      {   
          // fenetre  l'interieur du texte complet
         for (i2=0;i2<12;i2++) Aff_Buffer[i2]=*(p2+m2+i2);
      }
       else
      {  // fenetre de 12chars a cheval entre sortie et entree  du texte complet
         for (i2=0;i2<n2;i2++) Aff_Buffer[i2]=*(p2+m2+i2);
         for (i2=n2;i2<12;i2++) Aff_Buffer[i2]=*(p2+i2-n2);
      }
    }
    remplis_buffer_with_string(Aff_Buffer) ;
    m2++;
  } 
    Tour++;
    _Affiche_96bits_12_Matrices_H();
    
    if(Bavard_Forcee==0)  Affiche_12_Matrices_en_Texte_sur_Terminal();
    New_decalage_96bits_en_ASM_X();
    for (i2=0;i2<Speed;i2++) __delay_ms(1);
    j2++;  // next decalage car  gauche
    
   //--------------------------------------------------------------------------
   // interface operateur via Commande clavier terminal ou via blueTooth Terminal
   //--------------------------------------------------------------------------
   if (Flag_Buffer1==1) // c'est donc une Interrupt UART
   {
     p1=Buffer1;
     
     if((*(p1)=='H') && (*(p1+3)=='p'))     //Help<CR>
     {
       CPrint("\r\n Help : Help<CR>  \r\n");
       CPrint(" RTC Update: U;30;05;23;15;36;02#<CR>\r\n");
       CPrint(" exemple pour :30 Mai 2023 02(Mardi) 15H36\r\n");
       CPrint(" Plage Luminosite Minimale PLM=23:01<CR>\r\n");
       CPrint(" Speed=xx  vitesse de defilement xx de 01 a 99 <CR>\r\n");
       CPrint(" Msg=x...x de 0 a 63 caracteres , si >0 , Affiche le message x...x pendant x Rep <CR>\r\n");
       CPrint(" et affichage Time reduit, pas d'info temperatures pendant le Msg Affiché <CR>\r\n");
       CPrint(" Rep=xx de 01 a 99 :Repetition du Msg pendant xx Cycles  <CR>\r\n");
       CPrint(" Lum=xx de 00 a 15 :Reglage Luminosite en mode JOUR  <CR>\r\n");
       CPrint(" BAVA=0 ou 1 -> Bavard pour tracage programme\r\n");
        CRLF1();
      p1=0;
     }
     if((*(p1)=='U') &&   ( ( *(p1+20)=='#') || (*(p1+20)==';')  ) )
        //U;12;05;18;15;36;02;#<CR>
     {
       CPrint(" Cde RTC Update : ");
       Print(Buffer1);
       CRLF1();
       MAJ_RTC();
       DS3231_Read_All_Registers();
       //Refresh_Date_Time() ;
       Sec= Bcd2Dec(second);
       Mn= Bcd2Dec(minute);
       Hour= Bcd2Dec(heure);
       Month= Bcd2Dec(mois);
      p1=0;
     }
     // Msg=xxxx<CR>
     if((*(p1)=='M') && (*(p1+1)=='s') && (*(p1+2)=='g')&& (*(p1+3)=='='))
     {
     // GIE_bit=0;
       *(Buffer1+67)=0; // limitation longueur maximum du message à 63 cars
        *(Msg)=0;
        strcpy(Msg,Buffer1+4); // passe par dessus "Msg="
        Print(Msg); CRLF1();
       k=strlen(Msg);
       if (k>4)
       {  
         CPrint(" OK for Msg\r\n");
         __delay_ms(50);
         if ( Rep>0)
          {
           Repetition_Affichage_Texte=Rep;
           Clear_12_Matrice();
           j2=0;m2=0;
           UpDate_Trame();
          }
        }
        else
        {
          CPrint(" Msg doit etre >0 et <63 cars!\r\n");
          Repetition_Affichage_Texte=0;
          *(Msg)=0;
         }
       p1=0;
      //GIE_bit=1;
      }
        //speed=10<CR>
     if((*(p1)=='S') && (*(p1+1)=='p') && (*(p1+2)=='e')&& (*(p1+3)=='e')&& (*(p1+4)=='d') && (*(p1+5)=='='))
     {
    //   CPrint(" Cde=");
       Print(Buffer1);     TABUL;
       sprintf(CRam1," Old speed= %3d %c",Speed,9);
       Print(CRam1);  // TABUL;
       l=isdigit(*(p1+6))+ isdigit(*(p1+7));
       k=(*(p1+6)-48) *10+ *(p1+7)-48;
       if ((l==2) && (k>=1) && (k<99))
          {
           Speed=k;
           DATAEE_WriteByte(0x0076, (k/10)+48);
           __delay_ms(25);
           DATAEE_WriteByte(0x0077, (k%10)+48);
           __delay_ms(25);
           CPrint(" New = ");
           Read_Msg_From_Eeprom(0x0070,CRam1) ;
           Print(CRam1);
           CRLF1();
           }
           else
        CPrint(" BAD Speed value! must be between 02 and 98\r\n");
        p1=0;
      }
     // Lum=04<CR>
     if((*(p1)=='L') && (*(p1+1)=='u') && (*(p1+2)=='m')&& (*(p1+3)=='='))
     {
    //   CPrint(" Cde=");
       Print(Buffer1);  // TABUL;
       sprintf(CRam1," Old Lum= %3d %c",Lum,9);
       Print(CRam1);  
       l=isdigit(*(p1+4))+ isdigit(*(p1+5));
       k=(*(p1+4)-48) *10+ *(p1+5)-48;
       if ((l==2) && (k>=0) && (k<11))     // was <16
          {
           Lum=k & 0x0F;
             DATAEE_WriteByte(0x0094, (k/10)+48);
             __delay_ms(25);
             DATAEE_WriteByte(0x0095, (k%10)+48);
             __delay_ms(25);
           CPrint(" New = ");
           Read_Msg_From_Eeprom(0x0090,CRam1) ;
           Print(CRam1);
           CRLF1();
           }
           else
        CPrint(" BAD Lum value ! must be between 00 and 10\r\n");
        p1=0;
      }
      //Rep=04<CR>
     if((*(p1)=='R') && (*(p1+1)=='e') && (*(p1+2)=='p')&& (*(p1+3)=='=') )
      {
    //   CPrint(" Cde=");
       Print(Buffer1);     TABUL;
       sprintf(CRam1," Old Rep = %3d %c ",Rep,9);
       //WordToStr(Rep,CRam1);
       Print(CRam1); //  TABUL;
     //  CRLF1();
       l=isdigit(*(p1+4))+ isdigit(*(p1+5));
       k=(*(p1+4)-48) *10+ *(p1+5)-48;
       if (l==2)
       {
             Rep=k;
       }
       if ((Rep>=1) && (Rep<=80))
       {
             DATAEE_WriteByte(0x0084, (k/10)+48);
             __delay_ms(25);
             DATAEE_WriteByte(0x0085, (k%10)+48);
             __delay_ms(25);
              Read_Msg_From_Eeprom(0x0080,CRam1) ;
              CPrint(" New Rep= ");
           //  sprintf(CRam1," New Rep = %3d %c\r\n",Rep,9);
              Print(CRam1);//CRLF1();
              Repetition_Affichage_Texte=Rep;
             
         }
         else
        {
            Rep=0;
            CPrint(" BAD Rep value! must between  02 and 50\r\n");
         }
        p1=0;
      }
     //Bavard=1 ou 0<CR>
     if((*(p1)=='B') && (*(p1+1)=='A') && (*(p1+2)=='V')&& (*(p1+3)=='A')& (*(p1+4)=='=') )
      {
       Print(Buffer1); 
       if (   *(p1+5)=='1' || *(p1+5)=='0' )
       { 
           Bavard= *(p1+5)-48; 
       }
       CRLF1();
       p1=0;
      }
      // Plage Luminosité Minimale -> PLM=16:06<CR>  entre 16H00 du soir et 4H du matin
      if((*(p1)=='P') && (*(p1+1)=='L') && (*(p1+2)=='M') && (*(p1+3)=='=') && (strlen(Buffer1)>=9))
      {
      //  CPrint(" Cde: ");
        Print(Buffer1); TABUL;
        *(p1+6)=0;
        *(p1+9)=0;
         CPrint(" Old = ");
         Read_Msg_From_Eeprom(0x0060,CRam1) ;
         Print(CRam1);  TABUL;

        l=isdigit(*(p1+4))+ isdigit(*(p1+5))+isdigit(*(p1+7))+isdigit(*(p1+8));
        k=(*(p1+4)-48) *10+ *(p1+5)-48;
        m=(*(p1+7)-48) *10+ *(p1+8)-48;
        if ((l==4) && (k>=13) && (k<24) && (m>0) && (m<=8))
          {
             MaxHour=k;
             c1=*(p1+4);
             DATAEE_WriteByte(0x0064, c1);
             c1=*(p1+5);
             DATAEE_WriteByte(0x0065, c1);
             __delay_ms(25);
             MinHour=m;
             c1=*(p1+7);
             DATAEE_WriteByte(0x0067, c1);
             __delay_ms(25);
             c1=*(p1+8);
             DATAEE_WriteByte(0x0068, c1);
             __delay_ms(25);
           // envoi vers carte Horloge 7 segm
             CPrint("New PLM=");
             Read_Msg_From_Eeprom(0x0060,CRam1) ;
             __delay_ms(25);
             Print(CRam1);
             CRLF1();
            }
         else
             CPrint(" BAD PLM values! must be from [13.. 23 ] to [ 0 .. 8 ]");
        CRLF1();
        p1=0;
        }

      // COR1=-089<CR>  en 1/100em de degre
      if((*(p1)=='C') && (*(p1+1)=='O') && (*(p1+2)=='R') && (*(p1+4)=='=') && (strlen(p1)>=9))
      {
         CPrint(" Cde: ");
         Print(p1); TABUL;
         *(p1+10)=0;
         CPrint(" Old = ");
         Read_Msg_From_Eeprom(0x00A0,CRam1) ;
         Print(CRam1);
         l=  isdigit(*(p1+6))+isdigit(*(p1+7))+ isdigit(*(p1+8));
         if (l==3)
         {
            Q=atoi(p1+5);
            if ((Q<300) && (Q>-300) )
             {
             if (*(p1+3)=='1')
             {   COR1=Q;
                 FCOR1=(float)Q/100.0;
                 
                 for (i=0;i<4;i++)
                 {
                   DATAEE_WriteByte(0x00A5+i,*(p1+5+i));
                   __delay_ms(25);
                 }
                 CPrint("New COR");PrintChar(*p1+3);PrintChar(':');
                 Read_Msg_From_Eeprom(0x00A0,CRam1) ;
                 __delay_ms(25);
                 Print(CRam1);
               }
            }
           else
           CPrint(" BAD CORx value must in the range <-300 to +300]");
         }
       p1=0;
      }
     Flag_Buffer1=0;
    }
    
   // Bavard=0;
      
    // Plage Luminosite Minimale d' affichage  F (Nuit/jour)
    PLM_Status=0;
    Heure_En_Cours=(time[0]-48)*10 + (time[1]-48);
    if (Heure_En_Cours>=MinHour)
    {
     if (Heure_En_Cours<MaxHour) PLM_Status=1;
    }
    if (Heure_En_Cours>=0)
    {
      if (Heure_En_Cours<MinHour) PLM_Status=0;
    }
    if (PLM_Status==0)
    {
      SPI_Write_To_12x7219(REG_INTENSITY, 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
      }
      else
      {
       SPI_Write_To_12x7219(REG_INTENSITY,Lum,Lum,Lum,Lum, Lum,Lum,Lum,Lum,Lum,Lum,Lum,Lum);
    }
     __asm("btg LATA,4");  //Led_Rouge=!Led_Rouge;
      UpDate_Trame();
 } // do 
 while (1 );
}

  

/*
 * (11:16:57.008)  Presentation : PIC18F27K42 + texte defilant sur 12 matrices MAX7219
(11:16:57.041)  Directory :C:\MPLABX_Projects\_18F27K42_Horloge_12xMax7219_2023.X
(11:16:57.041)  Project : _18F27K42_Horloge_12xMax7219_2023
(11:16:57.041)  Source :  main.c _2023-0601
(11:16:57.041)  Config  Internal Fosc 64MHz
(11:16:57.041)  Autres :  config.h,table_char.h,RTC_DS3231_06.h ,One_Wire_2023.h 
(11:16:57.041)  Eeprom : ...
(11:16:57.041)  3 blocs de 4 matrices 8x8 Max7219
(11:16:57.041)  SPI RC0=CS ,RC1=CLCK,RC5=DOUT   UART 115200 bds  RA0= OWS DS18B20
(11:16:57.079)  RTC sur bus I2C1 HW : RC3=SCL,RC4=SDA
(11:16:57.079)  RB1 =Bavard Forcee , RB2==RTC Forcee
(11:16:57.079) 
(11:16:57.079)  Compile le Jun  1 2023 a 11:15:11 UTC
(11:16:57.079)  avec version XC8 :  2360 et PACK PIC18F-K_DFP 1.6.125
(11:16:57.079) 
(11:16:57.079)  L'Eeprom du PIC est  pr-initialise directement par le code
(11:16:57.079)  ReLecture des parametres en  Eeprom
(11:16:57.712) Horloge 12 MatricesH 8x8 2023
(11:16:58.354)  18F7K42,FOSC 64MHz,DS3231   
(11:16:58.364) 
(11:16:58.578) PLM=23:01
(11:16:58.798) Speed=10
(11:16:58.978) Rep=00
(11:16:59.158) Lum=01
(11:16:59.399) COR1=+001
(11:16:59.408) 
(11:16:59.442)  Init_I2C()  100Khz;
(11:16:59.442)  Test presence devices sur Bus I2C1
(11:16:59.442)  @ decimal # 174  soit @Device 7bits = 0X57 EEPROM 512bytes
(11:16:59.485)  @ decimal # 208  soit @Device 7bits = 0X68 RTC DS3231
(11:16:59.485) 
(11:16:59.485) 
(11:16:59.485)  #1 Active sortie RTC SQW=1Hz: 
(11:16:59.485)  GO
(11:16:59.485)  ok
(11:16:59.560)  ATTENTION : Possibilit de forage init RTC inhibe pendant les tests
(11:17:00.563)  Re-Lecture et affichage (si bavard=1)des 8 registres  RTC DS3231 
(11:17:00.573) 
(11:17:00.635) Jeu 01 Jun 23 11:12:48
(11:17:00.635) 
(11:17:01.574)  Config et Init One Wire bus pour capteur DS18B20 en RA0
(11:17:01.642)  temperature Amb. =23.44C
(11:17:01.642) 
(11:17:02.604)  Test Update()
(11:17:02.625)  11:12:48 Jeu 01 Jun 23.45 
(11:17:02.625)  Long Trame =    28  
(11:17:02.625) 
(11:17:02.625)  remplis buffer with string TEXTE 
(11:17:02.625)  11:12:48 Jeu 01 Jun 23.45 
(11:17:02.625)  Bit Bang Soft SPI  RC2=Clk ,RC1=Dout  RC0=CS -> Max7219:
(11:17:02.625)  Init Matrices MAX7219 
(11:17:03.747)  Clear Matrices MAX7219 
(11:17:03.814) 
(11:17:03.814) 
(11:17:03.814)  Buffer d'affichage Buffer depuis <OFFSET=0x0020h> (bank0) 24 longs 32bits ! 
(11:17:03.814)  Ajuste Luminosit  MAX7219 au minima 
(11:17:03.829) 
(11:17:03.829) 
(11:17:03.884)  TEXTE to display :  11:12:48 Jeu 01 Jun 23.45 
(11:17:03.884)  11:12:48 Jeu 01 Jun 23.45 
(11:17:03.884)  Long Trame =    28  
(11:17:03.884)  affiche nom de l'application
(11:17:03.884) 11:12:48
(11:17:03.884)  11:12:48 _18F27K42_Horloge_12xMax7219_2023
(11:17:03.884) 
(11:17:03.884)  Init Interrupt  UART RX 

 * 
(13:13:28.509)  13:09:15 _18F27K42_Horloge_12xMax7219_2023
(13:13:42.223)  13:09:28 Mer 31 Mai 23.76 
(13:13:55.944)  13:09:42 Mer 31 Mai 23.76 
(13:14:09.662)  13:09:56 Mer 31 Mai 23.76 
(13:14:18.919) Help
(13:14:19.018) 
(13:14:19.018)  Help : Help<CR>  
(13:14:19.018)  RTC Update: U;30;05;23;15;36;02#<CR>
(13:14:19.018)  exemple pour :30 Mai 2023 02(Mardi) 15H36
(13:14:19.018)  Plage Luminosite Minimale PLM=23:01<CR>
(13:14:19.018)  Speed=xx  vitesse de defilement xx de 02 a 99 <CR>
(13:14:19.018)  Msg=x...x de 0 a 63 caracteres , si >0 , Affiche le message x...x pendant x Rep <CR>
(13:14:19.018)  et affichage Time reduit, pas d'info temperatures pendant le Msg Affiché <CR>
(13:14:19.018)  Rep=xx de 04 a 99 :Repetition du Msg pendant xx Cycles  <CR>
(13:14:19.018)  Lum=xx de 00 a 15 :Reglage Luminosite en mode JOUR  <CR>
(13:14:19.018)  BAVA=0 ou 1 -> Bavard pour tracage programme
(13:14:19.018) 

(13:14:40.010) Speed=01
(13:14:40.052) Speed=01	 Old speed=  10 	 New = Speed=01
(13:14:40.280) 
(13:14:49.477)  13:10:35 Mer 31 Mai 23.76 
(13:15:01.110)  13:10:47 Mer 31 Mai 23.76 
(13:15:12.741)  13:10:59 Mer 31 Mai 23.82 
 * (13:14:49.477)  13:10:35 Mer 31 Mai 23.76 
(13:15:01.110)  13:10:47 Mer 31 Mai 23.76 
(13:15:12.741)  13:10:59 Mer 31 Mai 23.82 
 * 
(13:16:21.123) Rep=04
(13:16:21.165) Rep=04	 Old Rep =   0 	  New Rep= Rep=04
(13:16:21.501)  13:12:08 
(13:16:25.900)  13:12:12 
(13:16:26.049) Msg=Salut les copains
(13:16:26.093) Salut les copains
(13:16:26.093)  OK for Msg
(13:16:37.802)  13:12:24 Salut les copains
(13:16:49.022)  13:12:35 Salut les copains
(13:17:00.241)  13:12:46 Salut les copains
(13:17:11.460)  13:12:57 Salut les copains
(13:17:23.081)  13:13:09 Mer 31 Mai 23.82 
(13:17:34.702)  13:13:21 Mer 31 Mai 23.82 

 * 
 *  
  ===========================
 * 
 * BUILD SUCCESSFUL (total time: 284ms)
Loading code from C:/MPLABX_Projects/_18F27K42_Horloge_12xMax7219_2023.X/dist/default/production/_18F27K42_Horloge_12xMax7219_2023.X.production.hex...
Program loaded with pack,PIC18F-K_DFP,1.6.125,Microchip
Loading completed
Connecting to programmer...
*****************************************************
 
Connecting to MPLAB PICkit 4

Currently loaded versions:
Application version...........00.09.46
Boot version..................01.00.00
Script version................00.05.58
Script build number...........abbfe90327
Tool pack version ............1.15.1688
Target voltage detected
Target device PIC18F27K42 found.
Device Revision Id  = 0xa0010000

Erasing...

The following memory area(s) will be programmed:
program memory: start address = 0x0, end address = 0x1ffff
configuration memory
EEData memory
User Id Memory

Programming/Verify complete

 
 * 
   */
